package convertedc2java;


public abstract class Temperature {
    private final float CELSIUS_TO_KELVIN = 272.15f;
    private final float CELSIUS_TO_FARENHEIT = 9.0f / 5.0f;
    private final float FARENHEIT_TO_CELSIUS = 5.0f / 9.0f;
    private final float CELSIUS_FARENHEIT_OFFSET = 32.0f;

    private float celsius;
    private float farenheit;
    private float kelvin;

    
    public Temperature() {
        this.celsius   = 0.0f;
        this.farenheit = this.CELSIUS_FARENHEIT_OFFSET;
        this.kelvin    = this.CELSIUS_TO_KELVIN;
    }

    public float getCelsius() {
        return this.celsius;
    }

    public float getFarenheit() {
        return this.farenheit;
    }
    
    public float getKelvin() {
        return this.kelvin;
    }

    public void setCelsius ( float aCelsiusValue ) {
        this.celsius = aCelsiusValue;
        setFarenheitFromCelsius ( aCelsiusValue );
        setKelvinFromCelsius ( aCelsiusValue );
    }
    
    public void setFarenheit ( float aFarenheitValue ) {
        this.farenheit = aFarenheitValue;
        setCelsiusFromFarenheit ( aFarenheitValue );
        setKelvinFromFarenheit ( aFarenheitValue );
    }

    public void setKelvin ( float aKelvinValue ) {
        this.kelvin = aKelvinValue;
        setCelsiusFromKelvin ( aKelvinValue );
        setFarenheitFromKelvin ( aKelvinValue );
    }
    
    
    private void setKelvinFromCelsius ( float aCelsiusValue ) {
        this.kelvin = aCelsiusValue + this.CELSIUS_TO_KELVIN;
    }
    
    private void setKelvinFromFarenheit ( float aFarenheitValue ) {
        this.setKelvinFromCelsius ( ( aFarenheitValue - this.CELSIUS_FARENHEIT_OFFSET ) * this.FARENHEIT_TO_CELSIUS );
    }
    
    private void setCelsiusFromKelvin ( float aKelvinValue ) {
        this.celsius = aKelvinValue - this.CELSIUS_TO_KELVIN;
    }
    
    private void setCelsiusFromFarenheit ( float aFarenheitValue ) {
        this.celsius = ( aFarenheitValue - this.CELSIUS_FARENHEIT_OFFSET ) * this.FARENHEIT_TO_CELSIUS;
    }
    
    private void setFarenheitFromKelvin ( float aKelvinValue ) {
        this.farenheit = ( aKelvinValue - this.CELSIUS_TO_KELVIN ) * this.CELSIUS_TO_FARENHEIT + this.CELSIUS_FARENHEIT_OFFSET;
    }
    
    private void setFarenheitFromCelsius ( float aCelsiusValue ) {
        this.farenheit = aCelsiusValue * this.CELSIUS_TO_FARENHEIT + this.CELSIUS_FARENHEIT_OFFSET;
    }
}